Debian Bug report logs - #680439
gcc-4.7: Fails to build glibc (git master) [amd64]: '__EI___isnan' aliased to external symbol '__GI___isnan'

version graph

Package: gcc-snapshot; Maintainer for gcc-snapshot is Debian GCC Maintainers <debian-gcc@lists.debian.org>; Source for gcc-snapshot is src:gcc-snapshot.

Reported by: Daniel Schepler <dschepler@gmail.com>

Date: Fri, 22 Jun 2012 23:18:01 UTC

Severity: important

Found in version gcc-snapshot/20120704-1

Done: Matthias Klose <doko@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#678589; Package gcc-4.7. (Fri, 22 Jun 2012 23:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Schepler <dschepler@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. (Fri, 22 Jun 2012 23:18:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Daniel Schepler <dschepler@gmail.com>
To: submit@bugs.debian.org
Subject: gcc-4.7: Fails to build glibc (git master) [amd64]: '__EI___isnan' aliased to external symbol '__GI___isnan'
Date: Fri, 22 Jun 2012 16:16:08 -0700
[Message part 1 (text/plain, inline)]
Package: gcc-4.7
Version: 4.7.1-1
Severity: normal

(See http://sourceware.org/bugzilla/show_bug.cgi?id=14281 for past
history on my investigations on this issue.)

When I try to build glibc, the git master branch, on Debian sid amd64,
I get this error:

make  subdir=math -C math ..=../ subdir_lib
make[2]: Entering directory `/home/lfs/sources/glibc-2.16/math'
gcc ../sysdeps/ieee754/dbl-64/wordsize-64/s_isnan.c -c -std=gnu99
-fgnu89-inline  -O2 -Wall -Winline -Wwrite-strings
-fmerge-all-constants -frounding-math -g -Wstrict-prototypes   -fPIC
 -Wno-uninitialized   -D__NO_MATH_INLINES
-D__LIBC_INTERNAL_MATH_INLINES -I../include
-I/home/lfs/sources/libc-build/math -I/home/lfs/sources/libc-build
-I../sysdeps/unix/sysv/linux/x86_64/64/nptl
-I../sysdeps/unix/sysv/linux/x86_64/64
-I../nptl/sysdeps/unix/sysv/linux/x86_64
-I../nptl/sysdeps/unix/sysv/linux/x86 -I../sysdeps/unix/sysv/linux/x86
-I../sysdeps/unix/sysv/linux/x86_64
-I../sysdeps/unix/sysv/linux/wordsize-64
-I../nptl/sysdeps/unix/sysv/linux -I../nptl/sysdeps/pthread
-I../sysdeps/pthread -I../sysdeps/unix/sysv/linux -I../sysdeps/gnu
-I../sysdeps/unix/inet -I../nptl/sysdeps/unix/sysv
-I../sysdeps/unix/sysv -I../sysdeps/unix/x86_64 -I../nptl/sysdeps/unix
-I../sysdeps/unix -I../sysdeps/posix -I../nptl/sysdeps/x86_64/64
-I../sysdeps/x86_64/64 -I../sysdeps/x86_64/fpu/multiarch
-I../sysdeps/x86_64/fpu -I../sysdeps/x86/fpu
-I../sysdeps/x86_64/multiarch -I../nptl/sysdeps/x86_64
-I../sysdeps/x86_64 -I../sysdeps/x86 -I../sysdeps/ieee754/ldbl-96
-I../sysdeps/ieee754/dbl-64/wordsize-64 -I../sysdeps/ieee754/dbl-64
-I../sysdeps/ieee754/flt-32 -I../sysdeps/wordsize-64
-I../sysdeps/ieee754 -I../sysdeps/generic -I../nptl  -I.. -I../libio
-I.  -D_LIBC_REENTRANT -include ../include/libc-symbols.h  -DPIC
-DSHARED     -o /home/lfs/sources/libc-build/math/s_isnan.os -MD -MP
-MF /home/lfs/sources/libc-build/math/s_isnan.os.dt -MT
/home/lfs/sources/libc-build/math/s_isnan.os
../sysdeps/ieee754/dbl-64/wordsize-64/s_isnan.c:30:1: error:
'__EI___isnan' aliased to external symbol '__GI___isnan'
make[2]: *** [/home/lfs/sources/libc-build/math/s_isnan.os] Error 1
make[2]: Leaving directory `/home/lfs/sources/glibc-2.16/math'
make[1]: *** [math/subdir_lib] Error 2
make[1]: Leaving directory `/home/lfs/sources/glibc-2.16'
make: *** [all] Error 2

I tried building upstream GCC 4.7.1 with a configuration as close as
possible to Debian's:

../gcc-4.7.1/configure -v
--enable-languages=c,c++,go,fortran,objc,obj-c++ --prefix=/usr
--program-suffix=-4.7 --enable-shared --enable-linker-build-id
--with-system-zlib --libexecdir=/usr/lib --without-included-gettext
--enable-threads=posix --with-gxx-include-dir=/usr/include/c++/4.7
--libdir=/usr/lib --enable-nls --with-sysroot=/ --enable-clocale=gnu
--enable-libstdcxx-debug --enable-libstdcxx-time=yes
--enable-gnu-unique-object --enable-plugin --enable-objc-gc
--with-arch-32=i586 --with-tune=generic --enable-checking=release
--build=x86_64-linux-gnu --host=x86_64-linux-gnu
--target=x86_64-linux-gnu

(This was after doing "(cd /usr/lib; ln -sv x86_64-linux-gnu/*.o .)"
to work around upstream GCC not supporting multiarch.)  Once that was
done building, `pwd`/gcc/xgcc -B`pwd`/gcc -c /tmp/s_isnan.i -o
/tmp/s_isnan.o worked fine from the build directory, whereas gcc -c
/tmp/s_isnan.i -o /tmp/s_isnan.o reproduced the error.  So it looks
like this is most likely an issue introduced by one of the
Debian-specific patches.  (Also, it's a regression from Debian
gcc-4.6, which can compile the same preprocessed source without error.
 I've also verified gcc-4.6 can build all of glibc git master without
error.)

Attaching the preprocessed s_isnan.i file.
-- 
Daniel Schepler
[s_isnan.i (application/octet-stream, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#678589; Package gcc-4.7. (Sun, 01 Jul 2012 22:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. (Sun, 01 Jul 2012 22:51:03 GMT) Full text and rfc822 format available.

Message #10 received at 678589@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Daniel Schepler <dschepler@gmail.com>
Cc: 678589@bugs.debian.org
Subject: Re: gcc-4.7: Fails to build glibc (git master) [amd64]: '__EI___isnan' aliased to external symbol '__GI___isnan'
Date: Sun, 1 Jul 2012 17:46:54 -0500
Hi,

Daniel Schepler wrote:

> When I try to build glibc, the git master branch, on Debian sid amd64,
> I get this error:
[...]
> ../sysdeps/ieee754/dbl-64/wordsize-64/s_isnan.c:30:1: error: '__EI___isnan' aliased to external symbol '__GI___isnan'
[...]
> I tried building upstream GCC 4.7.1 with a configuration as close as
> possible to Debian's:
[...]
>                                                         Once that was
> done building, `pwd`/gcc/xgcc -B`pwd`/gcc -c /tmp/s_isnan.i -o
> /tmp/s_isnan.o worked fine from the build directory

As mentioned in /usr/share/doc/gcc-4.7/README.Debian.<arch>.gz, gcc
4.7.1-1 had some later changes from the 4.7 branch applied, if I
remember correctly, which could account for the difference.

How does 4.7.1-2 do?

Curious,
Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#678589; Package gcc-4.7. (Mon, 02 Jul 2012 16:57:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Schepler <dschepler@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. (Mon, 02 Jul 2012 16:57:12 GMT) Full text and rfc822 format available.

Message #15 received at 678589@bugs.debian.org (full text, mbox):

From: Daniel Schepler <dschepler@gmail.com>
To: Jonathan Nieder <jrnieder@gmail.com>
Cc: 678589@bugs.debian.org
Subject: Re: gcc-4.7: Fails to build glibc (git master) [amd64]: '__EI___isnan' aliased to external symbol '__GI___isnan'
Date: Mon, 2 Jul 2012 09:53:28 -0700
On Sun, Jul 1, 2012 at 3:46 PM, Jonathan Nieder <jrnieder@gmail.com> wrote:
> How does 4.7.1-2 do?
>
> Curious,
> Jonathan

Still fails.
-- 
Daniel Schepler




Marked as found in versions gcc-4.7/4.7.1-2. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Mon, 02 Jul 2012 18:51:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#678589; Package gcc-4.7. (Thu, 05 Jul 2012 15:18:25 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Schepler <dschepler@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. (Thu, 05 Jul 2012 15:18:27 GMT) Full text and rfc822 format available.

Message #22 received at 678589@bugs.debian.org (full text, mbox):

From: Daniel Schepler <dschepler@gmail.com>
To: 678589@bugs.debian.org
Cc: Jonathan Nieder <jrnieder@gmail.com>
Subject: Status update
Date: Thu, 5 Jul 2012 08:16:56 -0700
s_isnan.i still fails to build with gcc-4.7 4.7.1-3.  I just tried
with gcc-snapshot 20120704-1, and it fails there too.
-- 
Daniel Schepler




Severity set to 'important' from 'normal' Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 05 Jul 2012 20:45:09 GMT) Full text and rfc822 format available.

Bug 678589 cloned as bug 680439 Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 05 Jul 2012 20:45:10 GMT) Full text and rfc822 format available.

Bug reassigned from package 'gcc-4.7' to 'gcc-snapshot'. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 05 Jul 2012 20:45:10 GMT) Full text and rfc822 format available.

No longer marked as found in versions gcc-4.7/4.7.1-1 and gcc-4.7/4.7.1-2. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 05 Jul 2012 20:45:11 GMT) Full text and rfc822 format available.

Marked as found in versions gcc-snapshot/20120704-1. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 05 Jul 2012 20:45:12 GMT) Full text and rfc822 format available.

Added indication that bug 680439 blocks 678589 Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 05 Jul 2012 20:45:13 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC Maintainers <debian-gcc@lists.debian.org>:
Bug#680439; Package gcc-snapshot. (Fri, 05 Oct 2012 08:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to Debian GCC Maintainers <debian-gcc@lists.debian.org>. (Fri, 05 Oct 2012 08:09:03 GMT) Full text and rfc822 format available.

Message #39 received at 680439@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: 680439@bugs.debian.org
Subject: Re: gcc-4.7: Fails to build glibc [amd64]
Date: Fri, 5 Oct 2012 09:07:13 +0100
I've just tried this with glibc 2.16 and get the same problem.
Trying to build glibc2.15 with gcc 4.7 gave a very similar error (Same
'__EI___*' aliased to external symbol '__GI___*' with a different
variable name. 

Packaging from
svn://svn.debian.org/pkg-glibc/glibc-package/branches/eglibc-2.16/debian
libc sources from 
svn://svn.eglibc.org/branches/eglibc-2_16
(and the aarch64 patch from
http://sourceware.org/ml/libc-alpha/2012-10/msg00007.html munged to
fit debian eglibc layout)

This is now a blocker for the arm64 port, which only has gcc4.7
available and we need a cross-compiler to get started.

Will investigate further. 

Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/



Reply sent to Matthias Klose <doko@debian.org>:
You have taken responsibility. (Tue, 06 Nov 2012 19:39:06 GMT) Full text and rfc822 format available.

Notification sent to Daniel Schepler <dschepler@gmail.com>:
Bug acknowledged by developer. (Tue, 06 Nov 2012 19:39:06 GMT) Full text and rfc822 format available.

Message #44 received at 680439-done@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@debian.org>
To: 680439-done@bugs.debian.org
Subject: fixed in recent gcc-snapshot builds
Date: Tue, 06 Nov 2012 20:36:33 +0100
fixed in recent gcc-snapshot builds



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 05 Dec 2012 07:26:11 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 04:40:36 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.